-- ******************************************  --
-- ***  align-script v1.2 by le1setreter  ***  --
-- ***                            apr2009 ***  --
-- ******************************************  --

-- CREDITS: Many Thanks to all the people that helped me.
-- you can visit and contact me at http://www.le1setreter.de
	

clearselection() 

rollout obj2splRoll "obj2spl aligner" width:180 height:400
(
	
	local origObj					-- the object that should be instanced
	local origObjRotationX			-- the original rotation pvalues
	local origObjRotationY			-- the original rotation pvalues
	local origObjRotationZ			-- the original rotation pvalues
	local origObjScale				-- the original scale of the object
	
	
	local targetSpline				-- the spline where the the instances are aligned to
	local instanceCount				-- the amount of instances
	local instanceArray = #()		-- array for new createt instance objects
	
	local scaleDir					-- direction for scaling
	local rotateAxis				-- the axis in which object and instances have to rotatet
	
	
	-- selecting the object to clone/align:
	pickbutton chooseObj "pick object" width:140 tooltip:"pick the object to be duplicated"
	
	
	-- selecting the spline to align on:
	fn validSpline spl = (classof spl == Line) or (classof spl == SplineShape)
	pickbutton chooseSpl "pick spline" width:140 filter:validSpline tooltip:"pick the line/spline for alignment of objects"
	
	
	-- origObject rotations:
	button rotXBtn "rotX" pos:[20,70] tooltip:"rotate instances around x-axis"
	button rotYBtn "rotY" pos:[60,70] tooltip:"rotate instances around y-axis"
	button rotZBtn "rotZ" pos:[100,70] tooltip:"rotate instances around z-axis"
	
	
	-- origObject scaling:
	button scaleUpBtn "scale up" pos:[20,100] tooltip:"scale up instances"
	button scaleDownBtn "scale down" pos:[80,100] tooltip:"scale down instances"
	
	
	-- setting amount of duplicates/instances
	spinner instCount "InstanceCount:"  pos:[60,150] width:80 height:16 range:[2,1000,0] type:#integer tooltip:"set amount of instances"
	
	
	-- preview Button
	button prevBtn "create/update view" pos:[20,190] tooltip:"create/update view"
	
	
	-- cancel Button
	button redoBtn "reset" pos:[130,190] tooltip:"delete instances"
	
	
	-- infobox
	label lab10 ""
	label lab11 "remember: settings will be " align:#left
	label lab12 "lost after closing window." align:#left
	

	-- select spline button
	button slctSpl "select/edit spline vertex" pos:[20,290] tooltip:"select spline"
	
	-- select spline button
	button slctObj "select/edit object vertex" pos:[20,320]	tooltip:"select object"
	
	-- move instances to (new)  layer
	button intoLayer "export all into new layer" pos:[20,370] tooltip:"(create and) movie instances into (new) layer"

	
	
	
	fn cloneAlign = (
		
		if (instanceArray.count >= 1)
			then (
				for k = 1 to instanceArray.count do (
				delete instanceArray[k]
				)
				-- empty array
				instanceArray = #()
		) -- end if
			
		for i = 0 to instanceCount do (
			
			percentState = 100.0/instanceCount * i
			
			new_copy = instance origObj 											--instance the object
			new_copy.name = uniquename (origObj.name+"_Instance") 					--rename it
			append instanceArray new_copy											-- add to instance array
			-- print instanceArray
			new_copy.pos.controller = path follow:true path:targetSpline constantVel:true percent:percentState allowUpsideDown:on		-- align/follow path 
			new_copy.transform = origObj.transform 									--copy the TMatrix to orient correctly
		) -- end for
		
	) --end fn
	
	fn deleteInstances = (
		for k = 1 to instanceArray.count do (
			delete instanceArray[k]
		) -- end for
		-- empty array
		instanceArray = #()
	) -- end fn
	
	
	
	fn rotateOrigObj = (
		
			if rotateAxis == "x" do(
				newRot = origObj.rotation.x_rotation + 90
				origObj.rotation.x_rotation = newRot
			) -- end if
			
			if rotateAxis == "y" do(
				newRot = origObj.rotation.y_rotation + 90
				origObj.rotation.y_rotation = newRot
			) -- end if
			
			if rotateAxis == "z" do(
				newRot = origObj.rotation.z_rotation + 90
				origObj.rotation.z_rotation = newRot
			) -- end if
			
		if (instanceArray.count >= 1)
			then (
				for k = 1 to instanceArray.count do (
					
					if rotateAxis == "x" do(
						newRot = instanceArray[k].rotation.x_rotation + 90
						instanceArray[k].rotation.x_rotation = newRot
					) -- end if
					
					if rotateAxis == "y" do(
						newRot = instanceArray[k].rotation.y_rotation + 90
						instanceArray[k].rotation.y_rotation = newRot
					) -- end if
					
					if rotateAxis == "z" do(
						newRot = instanceArray[k].rotation.z_rotation + 90
						instanceArray[k].rotation.z_rotation = newRot
					) -- end if
					-- delete instanceArray[k]
				)  -- end for
			)
			else (
				-- messagebox "no array"
		) -- end if
	) -- end fn
	
		
	-- if object is scaled:
	fn scaleOrigObj scaleDir = (
		
		if scaleDir == "upDir" do (
			scaleSize = [1.1,1.1,1.1]
		) -- end if
		
		if scaleDir == "downDir" do(
			scaleSize = [0.9,0.9,0.9]
		) -- end if
		
		scale origObj scaleSize
		
		if (instanceArray.count >= 1)
			then (
				for l = 1 to instanceArray.count do (
					scale instanceArray[l] scaleSize
				)
			) else (
				-- nothing
		) -- end if
	) -- end fn
	
	
	
	fn manageLayer = (
		
		messagebox "new layer will be activated!"
		
		rnd = random 1000 9999
		obj2splLayer = LayerManager.newLayerFromName ("obj2spline_"+rnd as string)
		
		obj2splLayer.current = true
		obj2splLayer.renderable = false
		
		obj2splLayer.addNode origObj
		obj2splLayer.addNode targetSpline
		
		if (instanceArray.count >= 1)
			then (
				for l = 1 to instanceArray.count do (
					obj2splLayer.addNode instanceArray[l]
					-- delete instanceArray[k]
				)  -- end for
			) else (
				-- messagebox "no array"
		) -- end if
		
		intoLayer.enabled = false
	) -- end fn
	
	
	
	-- if object is picked:
	on chooseObj picked obj do( 
		--see if the user did not cancel the picking...
		if obj != undefined do(
			--if he did not, make the box's wireframe red:
			obj.wirecolor = red
			origObj = obj
			--and display the name of the object on the button:
			chooseObj.text = obj.name
			
			origObjRotationX = origObj.rotation.x_rotation
			origObjRotationY = origObj.rotation.y_rotation
			origObjRotationZ = origObj.rotation.z_rotation
			
			origObjScale = origObj.scale
			print origObjScale
			
		) --end if
	) --end on
	
	
	-- if spline is picked:
	on chooseSpl picked spl do( 
		--see if the user did not cancel the picking...
		if spl != undefined do(
			--if he did not, make the box's wireframe red:
			spl.wirecolor = red
			targetSpline = spl
			--and display the name of the object on the button:
			chooseSpl.text = spl.name
			)
	) --end on

	
	-- if spinner is changed:
	on instCount changed val do(
		instanceCount = val
		-- print val
	) --end on

	
	-- id preview button is pressed:
	on prevBtn pressed do (
		-- messagebox "do the action"
		clearselection()
		cloneAlign()
	) --end on

	
	-- if cancel button is pressed:
	on redoBtn pressed do (
		deleteInstances()
	) -- end on
	
	
	-- if one of the rotation button is pressed:
	on rotXBtn pressed do (
		rotateAxis = "x"
		rotateOrigObj()
	) -- end on
		
	on rotYBtn pressed do (
		rotateAxis = "y"
		rotateOrigObj()
	) -- end on
	
	on rotZBtn pressed do (
		rotateAxis = "z"
		rotateOrigObj()
	) -- end on
	
	
	-- if one of the scale button is pressed:
	on scaleUpBtn pressed do (
		scaleDir = "upDir"
		scaleOrigObj scaleDir
	) -- end on
	
	on scaleDownBtn pressed do (
		scaleDir = "downDir"
		scaleOrigObj scaleDir
	) -- end on
	
	
	-- if spline is selected:
	on slctSpl pressed do (
		clearselection() 
		select targetSpline
		subobjectLevel = 1
	) -- end on
	
	
	-- if object is selected:
	on slctObj pressed do (
		clearselection() 
		select origObj
		if (classof origObj == Editable_Poly) do subobjectLevel = 1
	) -- end on
	
	
	-- if layer is selected:
	on intoLayer pressed do (
		manageLayer() 
	) -- end on
	
	
	on obj2splRoll close do(
		
		/*
		origObj.rotation.x_rotation = origObjRotationX
		origObj.rotation.y_rotation = origObjRotationY
		origObj.rotation.z_rotation = origObjRotationZ
		
		origObj.scale = origObjScale
		
		-- max undo
		*/
		
	) --end on

	
	

)

createdialog obj2splRoll



